//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

#ifndef __DEFINITIONS_H__
#define __DEFINITIONS_H__

// IO types
#if defined(unix) || defined(__VMS)
typedef int HANDLE;
#define INVALID_HANDLE_VALUE (-1)

#elif defined(WIN32)
#include <windows.h>

#endif

#include <sys/types.h>

//  Auxiliary types
typedef unsigned char  byte_t;
typedef unsigned char  ubyte_t;
typedef unsigned short word_t;
typedef unsigned short uword_t;
typedef unsigned int   dword_t;
typedef unsigned int   udword_t;

#if defined(unix)

typedef unsigned long long qword_t;

#if defined(sun)
#define bzero(a,b) memset(a,'\0',b)
#include <limits.h>
#define NAME_MAX PATH_MAX
#endif

#elif defined(_WIN32)

typedef unsigned __int64 qword_t;
#define bzero(a,b) memset(a,'\0',b)
#define PATH_MAX _MAX_PATH
#define NAME_MAX _MAX_FNAME

#endif

typedef dword_t lbn_t;
#define INVALID_LBN	BOOT_BLK_LBN

#define UNUSED 
#define NOTINUSE(x)

// Resolve here endianity issues in On-Disk structures:
#if defined(sun)
#include "endian_conv.h"
typedef  alien_endian_word_t ods_word_t;
typedef  alien_endian_dword_t ods_dword_t;
#else
typedef  word_t ods_word_t;
typedef  dword_t ods_dword_t;
#endif

#define SS_NORMAL   1
#define SS_ERROR    0

#define blocks2clusters(nblk, clust_size) \
	((nblk + clust_size - 1) / clust_size)

#endif
