//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

#ifndef __ASSERT_H__
#define __ASSERT_H__

extern void f11_error(const char* msg, ...);
extern void f11_info(const char* msg, ...);

#if defined(_DEBUG)

extern void f11_trace(const char* msg, ...);
extern void f11_enable_trace();
extern void f11_disable_trace();
extern int f11_trace_enabled;

#define TRACE(b) f11_trace b;

#if defined(unix) && !defined(sun)

#include <unistd.h>
#include <stdio.h>
#include <signal.h>

extern void __do_assert( char*, int );
extern int  __under_debug();

#define ASSERT(val) \
if( !(val) ){ \
    fprintf(stderr,"%s:%d: FAILED ASSERTION `%s'\n",__FILE__,__LINE__,#val);\
    fflush(stderr);\
    if(__under_debug()) {\
        kill(getpid(), SIGTRAP); }\
    else __do_assert(__FILE__,__LINE__); }

#define main(a,b) user_main(a,b)
extern void f11_init_assert(int argc, char* argv[]);

#elif (defined(WIN32) || defined(__VMS) || defined(sun))

#include <assert.h>
#define ASSERT(a) assert(a)

#endif	// End of UNIX part
#else   // _DEBUG part

#define ASSERT(a)
#define TRACE(b)

#endif  // End of _DEBUG part

#endif  // __ASSERT_H__
