//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

// Files-11 Structure level 2 

#ifndef __F11FILE_SEQ_H__
#define __F11FILE_SEQ_H__

#include "f11file.h"

#define MAX_RECORD_LEN	(65535 - 2)

//  File structure
class f11_file_sequential : public f11_file
{
public:

    // Currently is (must be) used by read_write_file_blk() only.
    dword_t window_pos;	// current file pos

    int	    text_mode;
    dword_t f_size;

    // Context for text mode access
    typedef enum {
       gs_trans  = 0,
       gs_eol1	 = 1,
       gs_eol2	 = 2
    } text_mode_state;

    word_t  text_mode_rem_bytes;	//record remainder in bytes
    word_t  text_mode_cur_state;	//state of data translation

    char    record_buf[MAX_RECORD_LEN + 2];
    int	    record_len;

    //  Getc() and Putc() functions
    virtual int f11_bin_getc();		// get char function
    virtual int f11_bin_putc(char c);	// put char function

    virtual int f11_text_getc();	// get char function
    virtual int f11_text_putc(char c);	// put char function

    virtual int flush_record();

public:

    f11_file_sequential() : window_pos(0), 
			    text_mode_rem_bytes(0),
			    text_mode_cur_state(gs_eol2),
			    text_mode(0),
			    record_len(0)
    {}

    ~f11_file_sequential() {}
};

#endif 	//__F11FILE_SEQ_H__
