//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

#ifndef __FIBDEF_LOADED
#define __FIBDEF_LOADED 1

// I/O FUNCTION CODE DEFINITIONS

// START PHYSICAL I/O FUNCTION CODES
#define IO__NOP 0                       // NO OPERATION
#define IO__PHYSICAL 31                 // HIGHEST PHYSICAL I/O FUNCTION CODE

// START LOGICAL I/O FUNCTION CODES
#define IO__LOGICAL 47                  // HIGHEST LOGICAL I/O FUNCTION CODE

// START VIRTUAL I/O FUNCTION CODES
#define IO__WRITEVBLK 48                // WRITE VIRTUAL BLOCK
#define IO__READVBLK 49                 // READ VIRTUAL BLOCK
#define IO__ACCESS 50                   // ACCESS FILE
#define IO__PSXWRITEVBLK 50             // POSIX WRITE VIRTUAL
#define IO__CREATE 51                   // CREATE FILE
#define IO__DEACCESS 52                 // DEACCESS FILE
#define IO__PSXREADVBLK 52              // POSIX READ VIRTUAL
#define IO__DELETE 53                   // DELETE FILE
#define IO__MODIFY 54                   // MODIFY FILE
#define IO__NETCONTROL 54               // X25 NETWORK CONTROL FUNCTION
#define IO__READPROMPT 55               // READ TERMINAL WITH PROMPT
#define IO__SETCLOCK 55                 // SET CLOCK
#define IO__AUDIO 55                    // CD-ROM AUDIO
#define IO__ACPCONTROL 56               // MISCELLANEOUS ACP CONTROL
#define IO__STARTDATA 56                // START DATA
#define IO__IOCTLV 56                   // GENERIC UNIX IOCTL FUNCTIONS
#define IO__MOUNT 57                    // MOUNT VOLUME
#define IO__TTYREADALL 58               // TERMINAL READ PASSALL
#define IO__DISMOUNT 58                 // F64 dismount
#define IO__TTYREADPALL 59              // TERM READ W/PROMPT PASSALL
#define IO__CONINTREAD 60               // Connect to interrupt readonly
#define IO__CONINTWRITE 61              // Connect to interrupt with write 
#define IO__READDIR 62                  // READ DIRECTORY CONTENTS
#define IO__VIRTUAL 63                  // HIGHEST VIRTUAL I/O FUNCTION

// FUNCTION MODIFIER BIT DEFINITIONS
#define IO_M_FCODE 0x3F
#define IO_M_FMODIFIERS 0xFFC0
#define IO_M_INHERLOG 0x800
#define IO_M_ERASE 0x400
#define IO_M_EXFUNC 0x2000
#define IO_M_DATACHECK 0x4000
#define IO_M_INHRETRY 0x8000
#define IO_M_SYNCSTS 0x10000
#define IO_M_NOVCACHE 0x20000
#define IO_M_BUFOBJ 0x40000
#define IO_M_TRUSTED 0x80000
#define IO_M_INHSEEK 0x1000
#define IO_M_REVERSE 0x40
#define IO_M_NOWAIT 0x80
#define IO_M_INHEXTGAP 0x1000
#define IO_M_RETENSION 0x2000
#define IO_M_ALLOWFAST 0x4000
#define IO_M_MSCPMODIFS 0x100
#define IO_M_SHADOW 0x40
#define IO_M_LOCATE 0x80
#define IO_M_MSCP_FORMAT 0x40
#define IO_M_ALLHOSTS 0x40
#define IO_M_DISSOLVE 0x80
#define IO_M_NOCLEANUP 0x100
#define IO_M_SPINDOWN 0x40
#define IO_M_EST_COM_PATH 0x40
#define IO_M_LCL_SRC_UNIT 0x80
#define IO_M_RTN_COM_PATH 0x100
#define IO_M_DEALC_ALL 0x40
#define IO_M_DEALC_HRN 0x80
#define IO_M_DEALC_ENTLOC 0x100
#define IO_M_DECR_AFC 0x200
#define IO_M_READ_ALL 0x400
#define IO_M_READ_HRN 0x800
#define IO_M_BREAK_CONN 0x1000
#define IO_M_STEPOVER 0x40
#define IO_M_COPYOP 0x100
#define IO_M_EXISTS 0x40
#define IO_M_CBS 0x80
#define IO_M_BOOTING 0x100
#define IO_M_VUEX_FC 0x200
#define IO_M_FORCEPATH 0x40
#define IO_M_PREFERRED_CPU 0x80
#define IO_M_COMMOD 0x40
#define IO_M_MOVETRACKD 0x80
#define IO_M_DIAGNOSTIC 0x100
#define IO_M_SKPSECINH 0x200
#define IO_M_DELDATA 0x40
#define IO_M_NOMRSP 0x40
#define IO_M_SWAP 0x100
#define IO_M_OPPOSITE 0x200
#define IO_M_CLSEREXCP 0x200
#define IO_M_CHUNKDIAG 0x40
#define IO_M_TBC 0x400
#define IO_M_ENAREP 0x40
#define IO_M_ACCESS 0x40
#define IO_M_CREATE 0x80
#define IO_M_DELETE 0x100
#define IO_M_MOUNT 0x200
#define IO_M_DMOUNT 0x400
#define IO_M_REMOUNT 0x800
#define IO_M_MOVEFILE 0x1000
#define IO_M_RWSHELVED 0x4000
#define IO_M_SETDIR 0x8000
#define IO_M_BINARY 0x40
#define IO_M_PACKED 0x80
#define IO_M_NOW 0x40
#define IO_M_STREAM 0x80
#define IO_M_READERCHECK 0x100
#define IO_M_WRITERCHECK 0x200
#define IO_M_NORSWAIT 0x400
#define IO_M_MB_ROOM_NOTIFY 0x40
#define IO_M_READATTN 0x80
#define IO_M_WRTATTN 0x100
#define IO_M_SETPROT 0x200
#define IO_M_READERWAIT 0x400
#define IO_M_WRITERWAIT 0x800
#define IO_M_NOECHO 0x40
#define IO_M_TIMED 0x80
#define IO_M_CVTLOW 0x100
#define IO_M_NOFILTR 0x200
#define IO_M_DSABLMBX 0x400
#define IO_M_PURGE 0x800
#define IO_M_TRMNOECHO 0x1000
#define IO_M_REFRESH 0x2000
#define IO_M_ESCAPE 0x4000
#define IO_M_EXTEND 0x8000
#define IO_M_CANCTRLO 0x40
#define IO_M_ENABLMBX 0x80
#define IO_M_NOFORMAT 0x100
#define IO_M_BREAKTHRU 0x200
#define IO_M_NEWLINE 0x400
#define IO_M_TYPEAHDCNT 0x40
#define IO_M_MAINT 0x40
#define IO_M_CTRLYAST 0x80
#define IO_M_CTRLCAST 0x100
#define IO_M_HANGUP 0x200
#define IO_M_OUTBAND 0x400
#define IO_M_TT_CONNECT 0x800
#define IO_M_TT_DISCON 0x1000
#define IO_M_TT_PROCESS 0x2000
#define IO_M_BRDCST 0x4000
#define IO_M_LOOP 0x80
#define IO_M_UNLOOP 0x100
#define IO_M_LINE_OFF 0x200
#define IO_M_SET_MODEM 0x400
#define IO_M_LINE_ON 0x800
#define IO_M_LOOP_EXT 0x1000
#define IO_M_AUTXOF_ENA 0x2000
#define IO_M_AUTXOF_DIS 0x4000
#define IO_M_INCLUDE 0x800
#define IO_M_TT_ABORT 0x1000
#define IO_M_POSIXINIT 0x40
#define IO_M_POSIXFLOW 0x80
#define IO_M_SET_POSIX 0x80
#define IO_M_CLEAR_POSIX 0x100
#define IO_M_SET_TERMIOS 0x200
#define IO_M_SET_PTC 0x400
#define IO_M_CLEAR_PTC 0x800
#define IO_M_FLUSH_TAB 0x1000
#define IO_M_FLUSH_OUTPUT 0x2000
#define IO_M_UPDATE_PTC 0x4000
#define IO_M_OUT_XOFF 0x100
#define IO_M_OUT_XON 0x200
#define IO_M_IN_XOFF 0x400
#define IO_M_IN_XON 0x800
#define IO_M_O_NONBLOCK 0x40
#define IO_M_INTERRUPT 0x40
#define IO_M_MULTIPLE 0x80
#define IO_M_LOCKBUF 0x100
#define IO_M_NOBLOCK 0x200
#define IO_M_ABORT 0x100
#define IO_M_SYNCH 0x200
#define IO_M_RESPONSE 0x40
#define IO_M_STARTUP 0x40
#define IO_M_SHUTDOWN 0x80
#define IO_M_ATTNAST 0x100
#define IO_M_CTRL 0x200
#define IO_M_SET_MAC 0x800
#define IO_M_UPDATE_MAP 0x1000
#define IO_M_ROUTE 0x2000
#define IO_M_RD_MEM 0x40
#define IO_M_RD_MODEM 0x80
#define IO_M_RD_COUNT 0x100
#define IO_M_CLR_COUNT 0x400
#define IO_M_SENSE_MAC 0x800
#define IO_M_SHOW_MAP 0x1000
#define IO_M_SHOW_ROUTE 0x2000
#define IO_K_SRRUNOUT 0                 // Send or rcv until cnt runout
#define IO_K_PTPBSC 8192                // Point to point BSC control
#define IO_K_LOOPTEST 57344             // Loop test

// X25 driver WRITEBLK function modifier bits.
#define IO_M_MORE 0x40
#define IO_M_QUALIFIED 0x80
#define IO_M_REDIRECT 0x40
#define IO_M_ACCEPT 0x80
#define IO_M_SETEVF 0x40
#define IO_M_WORD 0x40
#define IO_M_SETFNCT 0x200
#define IO_M_DATAPATH 0x400
#define IO_M_CYCLE 0x1000
#define IO_M_RESET 0x2000
#define IO_M_SETCUADR 0x100
#define IO_M_SETBSIZE 0x200
#define IO_M_SETPOOLSZ 0x400
#define IO_M_SETENQCNT 0x800
#define IO_M_CLEAR 0x1000
#define IO_M_LPBEXT 0x2000
#define IO_M_LPBINT 0x4000
#define IO_M_READCSR 0x8000
#define IO_M_NOCTSWAIT 0x40
#define IO_M_SLAVLOOP 0x80
#define IO_M_NODSRWAIT 0x100
#define IO_M_MAINTLOOP 0x200
#define IO_M_LASTBLOCK 0x400
#define IO_M_INTCLOCK 0x1000
#define IO_M_LT_CONNECT 0x40
#define IO_M_LT_DISCON 0x80
#define IO_M_LT_READPORT 0x100
#define IO_M_LT_MAP_PORT 0x200
#define IO_M_LT_RATING 0x400
#define IO_M_LT_SOL_INFO 0x800
#define IO_M_LT_RCV_INFO 0x1000
#define IO_M_LT_SETMODE 0x2000
#define IO_M_LT_SENSEMODE 0x4000
#define IO_M_LT_QUE_CHG_NOTIF 0x8000
#define IO_M_LT_MAP_FILLER 0x1
#define IO_M_LT_MAP_NODNAM 0x2
#define IO_M_LT_MAP_PORNAM 0x4
#define IO_M_LT_MAP_SRVNAM 0x8
#define IO_M_LT_MAP_LNKNAM 0x10
#define IO_M_LT_MAP_NETADR 0x20
#define IO_M_FLUSH 0x40
#define IO_M_WRITE_BARRIER 0x80
#define IO_M_MKFILL1 0x40
#define IO_M_ALLOWFAST_NEVER 0x80
#define IO_M_ALLOWFAST_PER_IO 0x100
#define IO_M_ALLOWFAST_ALWAYS 0x200

struct qio_fibdef {
    struct {
        byte_t fib_v_nowrite		: 1;	// NO OTHER WRITERS
        byte_t fib_v_dlock		: 1;	// ENABLE DEACCESS LOCK 
        byte_t fib_v_blk_lock		: 1;	// ENABLE RMS-11 BLOCK LOCKING
        byte_t fib_v_fastrdsqnos	: 1;	// READ HDRSEQ AND DATASEQ VALS
        byte_t fib_v_spool		: 1;	// SPOOL FILE ON CLOSE
        byte_t fib_v_writeck		: 1;	// ENABLE WRITE CHECK
        byte_t fib_v_seqonly		: 1;	// SEQUENTIAL ONLY ACCESS
        byte_t fib_v_seqno		: 1;	// STORE SEQNOS FOR THIS FILE

        byte_t fib_v_write		: 1;	// WRITE ACCESS
        byte_t fib_v_readck		: 1;	// ENABLE READ CHECK
        byte_t fib_v_noread		: 1;	// NO OTHER READERS
        byte_t fib_v_notrunc		: 1;	// FILE MAY NOT BE TRUNCATED
        byte_t fib_v_control		: 1;	// CONTROL ACCESS TO FILE
        byte_t fib_v_no_read_data	: 1;	// NO READ ACCESS TO FILE DATA
        byte_t fibdef___fill_3		: 2;	// SPARE

        byte_t fib_v_execute		: 1;	// ACCESS FOR EXECUTE (USE EXECUTE PROTECTION)
        byte_t fib_v_prsrv_atr		: 1;	// PRESERVE ORIGINAL ATTRIBUTES OF FILE 
        byte_t fib_v_rmslock		: 1;	// OPEN WITH RMS RECORD LOCKING
        byte_t fib_v_writethru		: 1;	// FORCE CACHE WRITE-THROUGH ON OPERATION
        byte_t fib_v_nolock		: 1;	// OVERRIDE ACCESS INTERLOCKS 
        byte_t fib_v_norecord		: 1;	// DO NOT RECORD FILE ACCESS
        byte_t fib_v_noverify		: 1;	// Do not perform compare on move.
        byte_t fib_v_change_vol		: 1;	// Allow Movefile move between volumes in a set.
    };

    byte_t	fib_b_wsize;			// WINDOW SIZE
    ODS_FID	fib_w_fid;
    ODS_FID	fib_w_did;
    dword_t	fib_l_wcc;			// WILD CARD CONTEXT
    
    struct {
        word_t fibdef___fill_7		: 3;
        word_t fib_v_allver		: 1;	// MATCH ALL VERSIONS
        word_t fib_v_alltyp		: 1;	// MATCH ALL TYPES
        word_t fib_v_allnam		: 1;	// MATCH ALL NAMES
        word_t fibdef___fill_8		: 2;

        word_t fib_v_wild		: 1;	// WILD CARDS IN FILE NAME
        word_t fib_v_newver		: 1;	// MAXIMIZE VERSION NUMBER
        word_t fib_v_supersede		: 1;	// SUPERSEDE EXISTING FILE
        word_t fib_v_findfid		: 1;	// SEARCH FOR FILE ID
        word_t fibdef___fill_9		: 2;
        word_t fib_v_lowver		: 1;	// LOWER VERSION OF FILE EXISTS
        word_t fib_v_highver		: 1;	// HIGHER VERSION OF FILE EXISTS
    };

    struct {
        word_t fib_v_alcon		: 1;	// ALLOCATE CONTIGUOUS
        word_t fib_v_alconb		: 1;	// CONTIGUOUS BEST EFFORT
        word_t fib_v_filcon		: 1;	// MARK FILE CONTIGUOUS
        word_t fib_v_aldef		: 1;	// ALLOCATE DEFAULT AMOUNT
        word_t fib_v_allocatr		: 1;	// PLACEMENT DATA PRESENT IN ATTRIBUTE LIST
        word_t fibdef___fill_10		: 2;
        word_t fib_v_extend		: 1;	// ENABLE EXTENSION

        word_t fib_v_trunc		: 1;	// ENABLE TRUNCATION
        word_t fib_v_nohdrext		: 1;	// INHIBIT EXTENSION HEADERS
        word_t fib_v_markbad		: 1;	// MARK BLOCKS BAD
        word_t fibdef___fill_11		: 3;
        word_t fib_v_noplace		: 1;	// DON'T ADD PLACEMENT POINTERS IN MOVEFILE
        word_t fib_v_nocharge		: 1;	// DON'T CHARGE DISKQUOTA
    };

    dword_t	fib_l_exsz;			// EXTEND SIZE 
    dword_t	fib_l_exvbn;			// EXTENSION VBN
    struct {
        byte_t fib_v_exact		: 1;	// EXACT PLACEMENT REQUIRED
        byte_t fib_v_oncyl		: 1;	// PUT ALLOCATION ON ONE CYLINDER
        byte_t fib_v_fill_2		: 6;
    };

    byte_t	fib_b_alalign;			// ALLOCATION ALIGNMENT
    word_t	fib_w_alloc [5];		// ALLOCATION LOCATION
    word_t	fib_w_verlimit;			// DIRECTORY ENTRY VERSION LIMIT
    word_t_t	fib_w_reserved;			// RESERVED
    dword_t	fib_l_aclctx;			// ACL CONTEXT FOR READ
    dword_t	fib_l_acl_status;		// RETURN STATUS FROM ACL OPERATION
    dword_t	fib_l_status;			// GENERAL STATUS LONGWORD
    dword_t	fib_l_alt_access;		// ALTERNATE ACCESS MASK
};
 
#endif //__FIBDEF_LOADED
 
