//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

#ifndef __FILEIO_H__
#define __FILEIO_H__

#include "definitions.h"
#include "f11lib_share.h"

// Open file mode
#define FILEIO_RO (1)
#define FILEIO_WO (0)
#define FILEIO_RW (0)

// File I/O
// Open_file, create or truncate the file if the flag is_read is 0
gblfunc_f11lib HANDLE	fileio_open_file(const char*, int is_read);
gblfunc_f11lib int	fileio_read_file(HANDLE h, void* buf, int length);
gblfunc_f11lib int	fileio_write_file(HANDLE h, void* buf, int length);
gblfunc_f11lib void	fileio_close_file(HANDLE h);
gblfunc_f11lib dword_t	fileio_file_size(const char* fs);
gblfunc_f11lib char*	fileio_absolute_file_name(const char* rel, 
						  char* absolute, int len);

// Operations with directories
gblfunc_f11lib int	fileio_file_chdir(const char* dir);
gblfunc_f11lib char*	fileio_file_getwd(char* dir, int size);

#endif
