//
// Copyright (C) 2000 Software Resources International SA
//
// This code is provided on an 'as is' basis.
// Software Resources International SA carries no responsibility for
// the application of this code in any way or form.
//

#ifndef __FT11_H__
#define __FT11_H__

#include "f11lib.h"
#include "f11file.h"
#include "f11liberr.h"

typedef void (*cmd_func)(int arg_numb, char* args[]);

typedef struct {
    char	cmd[24];
    int		min_chars;
    cmd_func	f;
} ft11_cmd;

#define MAX_COMMAND_LENGTH 8192
extern int cmd_done;

//  FT command handlers
extern void ft11_help_cmd(int arg_numb, char* args[]);
extern void ft11_open_cmd(int arg_numb, char* args[]);
extern void ft11_close_cmd(int arg_numb, char* args[]);
extern void ft11_bye_cmd(int arg_numb, char* args[]);
extern void ft11_ls_cmd(int arg_numb, char* args[]);
extern void ft11_cd_cmd(int arg_numb, char* args[]);
extern void ft11_cdup_cmd(int arg_numb, char* args[]);
extern void ft11_mkdir_cmd(int arg_numb, char* args[]);
extern void ft11_pwd_cmd(int arg_numb, char* args[]);
extern void ft11_get_cmd(int arg_numb, char* args[]);
extern void ft11_put_cmd(int arg_numb, char* args[]);
extern void ft11_lcd_cmd(int arg_numb, char* args[]);
extern void ft11_vi_cmd(int arg_numb, char* args[]);
extern void ft11_del_cmd(int arg_numb, char* args[]);
extern void ft11_ascii_cmd(int arg_numb, char* args[]);
extern void ft11_bin_cmd(int arg_numb, char* args[]);
extern void ft11_mode_cmd(int arg_numb, char* args[]);
extern void ft11_debug_cmd(int arg_numb, char* args[]);

//  VMS-like command handlers
extern void ft11_show_dev_cmd(int arg_numb, char* args[]);
extern void ft11_show_dev_full_cmd(int arg_numb, char* args[]);
extern void ft11_show_def_cmd(int arg_numb, char* args[]);
extern void ft11_dir_cmd(int arg_numb, char* args[]);
extern void ft11_dir_date_cmd(int arg_numb, char* args[]);
extern void ft11_dir_fileid_cmd(int arg_numb, char* args[]);
extern void ft11_dir_prot_cmd(int arg_numb, char* args[]);
extern void ft11_dir_size_cmd(int arg_numb, char* args[]);

//  Command processing functions
extern int  cmd_split(char* cmd_str, char* cmd_words[]);
extern void cmd_match(int num_words, char* cmd_words[]);

#define OFF(t,f) (dword_t)(&((t*)0)->f)

#define DF_MAX_STRING 512

#define FD_GET_VAL(c)\
val = strtol((c), &e, 8);\
if(val == 0 && e == (c)) {\
    err = -1;\
    break;}

#define FD_SET_VAL(i,val)\
sprintf(buf, "%s%08o\n", ft11_fd_keys[i].key, (dword_t)val)

typedef struct {
    char*	key;
    dword_t	offset;
    dword_t	type;	// 01 -> byte, 02 -> word, 03 -> word[2]
} ft11_fd_key;

//  Options
dword_t     ft11_options(int argc, char* args[], int num_opt, char* opt[]);
char* 	    ft11_next_arg(int argc, char* args[], dword_t* cur);

//  Get put
#define FT11_GETPUT_BUF_LEN F11_BLOCK_SIZE

#endif
